// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.0
//
// <auto-generated>
//
// Generated from file `Locator.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package Ice;

/**
 * The Ice locator interface. This interface is used by clients to
 * lookup adapters and objects. It is also used by servers to get the
 * locator registry proxy.
 * 
 * <p class="Note">The {@link Locator} interface is intended to be used by
 * Ice internals and by locator implementations. Regular user code
 * should not attempt to use any functionality of this interface
 * directly.
 * 
 **/
public interface _LocatorOperations
{
    /**
     * Find an object by identity and return its proxy.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     * @param __current The Current object for the invocation.
     **/
    void findObjectById_async(AMD_Locator_findObjectById __cb, Identity id, Ice.Current __current)
        throws ObjectNotFoundException;

    /**
     * Find an adapter by id and return its proxy (a dummy direct
     * proxy created by the adapter).
     * 
     * @param __cb The callback object for the operation.
     * @param id The adapter id.
     * 
     * @param __current The Current object for the invocation.
     **/
    void findAdapterById_async(AMD_Locator_findAdapterById __cb, String id, Ice.Current __current)
        throws AdapterNotFoundException;

    /**
     * Get the locator registry.
     * 
     * @param __current The Current object for the invocation.
     * @return The locator registry.
     * 
     **/
    LocatorRegistryPrx getRegistry(Ice.Current __current);
}
